Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-1.5x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/BQTerrace-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 600         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-1.5x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/BasketballDrive-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-1.5x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Cactus-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 500         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-1.5x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Kimono-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-1.5x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/ParkScene-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 240         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/PeopleOnStreet-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/PeopleOnStreet-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Traffic-2x.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Traffic-2x.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============
Index: branches/SHM-4.0-dev/cfg/per-sequence-svc/Traffic-SNR.cfg
===================================================================
--- branches/SHM-4.0-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 444)
+++ branches/SHM-4.0-dev/cfg/per-sequence-svc/Traffic-SNR.cfg	(revision 464)
@@ -2,4 +2,5 @@
 FrameSkip                     : 0           # Number of frames to be skipped in input
 FramesToBeEncoded             : 150         # Number of frames to be coded
+PhaseAlignment                : 0           # Sample location alignment between layers (0: zero position aligned, 1: central position aligned)
 
 #======== File I/O ===============