Index: branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecCfg.h	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecCfg.h	(revision 473)
@@ -84,5 +84,4 @@
 #if H_MV
   , m_maxLayerId(0)
-  , m_pchReconFiles(NULL) 
 #endif
   , m_pchReconFile(NULL)
Index: branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecTop.cpp	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecTop.cpp	(revision 473)
@@ -95,4 +95,11 @@
     m_pchReconFile = NULL;
   }
+#if H_3D_FIX
+  if (m_pchScaleOffsetFile)
+  {
+    free (m_pchScaleOffsetFile);
+    m_pchScaleOffsetFile = NULL; 
+  }
+#endif
 }
 
@@ -146,5 +153,4 @@
   Int  pocLastPic        = -MAX_INT;   
   
-  Int  layerIdLastPic    = 0; 
   Int  layerIdCurrPic    = 0; 
 
@@ -223,5 +229,4 @@
         if ( bNewPicture || !bitstreamFile )
         { 
-          layerIdLastPic    = layerIdCurrPic;  
           layerIdCurrPic    = nalu.m_layerId; 
           
Index: branches/HTM-DEV-0.3-dev1/source/Lib/TAppCommon/TAppComCamPara.cpp
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/Lib/TAppCommon/TAppComCamPara.cpp	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/Lib/TAppCommon/TAppComCamPara.cpp	(revision 473)
@@ -965,5 +965,7 @@
   //--- determine (virtual) camera parameter shift between view order index 1 and base view (view order index 0) ---
   Double        dCamPosShift, dPicPosShift;
+#if H_3D_PDM_CAM_PARAS
   Int           iMinVOI       = (1<<30);
+#endif
   Int           iMinAbsVOI    = (1<<30);
   Int           iMinAbsVOIId  = 0;
@@ -973,5 +975,7 @@
     if( iAbsVOI < iMinAbsVOI )
     {
+#if H_3D_PDM_CAM_PARAS
       iMinVOI      = m_aiViewOrderIndex[ iBaseId ];
+#endif
       iMinAbsVOI   = iAbsVOI;
       iMinAbsVOIId = iBaseId;
Index: branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/TComSlice.cpp	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/TComSlice.cpp	(revision 473)
@@ -1521,11 +1521,11 @@
   
 #if H_3D_DIM_DLT
-  Void TComVPS::setDepthLUTs(Int layerIdInVps, Int* idx2DepthValue, Int iNumDepthValues)
-  {
-    if( idx2DepthValue == NULL || iNumDepthValues == 0 ) // default mapping only
+  Void TComVPS::setDepthLUTs(Int layerIdInVps, Int* idxToDepthValueTable, Int iNumDepthValues)
+  {
+    if( idxToDepthValueTable == NULL || iNumDepthValues == 0 ) // default mapping only
       return;
     
     // copy idx2DepthValue to internal array
-    memcpy(m_iIdx2DepthValue[layerIdInVps], idx2DepthValue, iNumDepthValues*sizeof(UInt));
+    memcpy(m_iIdx2DepthValue[layerIdInVps], idxToDepthValueTable, iNumDepthValues*sizeof(UInt));
     
     UInt uiMaxDepthValue = ((1 << g_bitDepthY)-1);
Index: branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/TypeDef.h	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/TypeDef.h	(revision 473)
@@ -88,4 +88,5 @@
                                               // PKU_QC_DEPTH_INTRA_UNI_D0195
                                               // RWTH_SDC_DLT_B0036
+#define H_3D_FIX                          1   // Temporary for minor fixes
 #endif 
 
@@ -101,4 +102,5 @@
 #define H_3D_VSO_RM_ASSERTIONS            0   // Output VSO assertions
 #define H_3D_VSO_SYNTH_DIST_OUT           0   // Output of synthesized view distortion instead of depth distortion in encoder output
+#define H_3D_VSO_FIX                      0   // This fix should be enabled after verification 
 #endif
 
Index: branches/HTM-DEV-0.3-dev1/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/Lib/TLibDecoder/TDecTop.cpp	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/Lib/TLibDecoder/TDecTop.cpp	(revision 473)
@@ -52,5 +52,7 @@
   m_aaiCodedScale          = new Int* [ MAX_NUM_LAYERS ];
   m_aiViewId               = new Int  [ MAX_NUM_LAYERS ];
+#if !H_3D_FIX  
   m_aiLayerIdx             = new Int  [ MAX_NUM_LAYERS ];
+#endif
 
   m_bViewReceived          = new Bool [ MAX_NUM_LAYERS ];
Index: branches/HTM-DEV-0.3-dev1/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/Lib/TLibDecoder/TDecTop.h	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/Lib/TLibDecoder/TDecTop.h	(revision 473)
@@ -89,5 +89,7 @@
   Int**   m_aaiCodedScale;
   Int*    m_aiViewId;  
+#if !H_3D_FIX  
   Int*    m_aiLayerIdx;
+#endif
 
   Bool*   m_bViewReceived;
Index: branches/HTM-DEV-0.3-dev1/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-DEV-0.3-dev1/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 471)
+++ branches/HTM-DEV-0.3-dev1/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 473)
@@ -2787,4 +2787,5 @@
       
 #if H_3D_VSO // M35
+#if H_3D_VSO_FIX // This fix should be enabled after verification 
         Double dLambda;
         if ( m_pcRdCost->getUseLambdaScaleVSO() )
@@ -2794,4 +2795,7 @@
 
         Double cost      = (Double)uiSad + (Double)iModeBits * m_pcRdCost->getSqrtLambda();
+#else
+        Double cost      = (Double)uiSad + (Double)iModeBits * m_pcRdCost->getSqrtLambda();
+#endif
 #else
         Double cost      = (Double)uiSad + (Double)iModeBits * m_pcRdCost->getSqrtLambda();